Subject: Re: Make Gitweb behave like Apache mod_userdir

From: "J.H." <[email-masked]>
Date: Tue, 17 Nov 2009 15:52:23 -0800

Junio C Hamano wrote:
> Sylvain Rabot <[email-masked]> writes:
> 
>> On Tue, Nov 17, 2009 at 23:10, Junio C Hamano <[email-masked]> wrote:
>>> Sylvain Rabot <[email-masked]> writes:
>>>
>>>>> Wouldn't it be a good idea to somehow make this work well together with
>>>>> the --user-path feature of git-daemon?
>>>>>
>>>>> Perhaps the recommended name given in the example shouldn't be ~/gitweb,
>>>>> but more like ~/public_git, as this is like ~/public_html but for git
>>>>> repositories.  Then the end users will browse
>>>> As I said, it's configuration :)
>>> Wrong answer.
>> Am I passing a test ?
> 
> Sorry, but that wasn't what I meant.
> 
>>> Exactly because it is configurable, the document that outlines the
>>> recommended practice should suggest the best convention.  My point was
>>> that it is likely to be tied to "git"-ness of the specified directory
>>> under $HOME/, not limited to "gitweb"-ness, and it is wrong to recommend a
>>> name tied to "gitweb"-ness in this document.
>> Again, git is a brand new world for me and I don't know any of his
>> conventions yet.
> 
> I do not see this as git-specific conventions.
> 
> But suggesting ~/gitweb is perfectly excusable, especially if you did not
> know that git-daemon can respond to "git://host/~user/".
> 
> John warthog19 (hmm, I thought he used to be warthog9)

Yes I'm warthog9 (there's legacy reasons for warthog19 in the e-mail but 
- yeah)

> explained the above
> much better than I did.  People tend to cut and paste without thinking, so
> we should describe a good default layout in our documentation.
> 
>> I am not trying to impose my own conventions, I am just proposing an idea.
> 
> Yeah, I know.  We are all in this to improve things for people who follow
> us.

The biggest problem with the convention is not so much to impose our 
ideas on people, but that people have a tendency to, like I said, 
cut/paste the first thing they come across and never change it.

This isn't a bash on implementers by any stretch of the imagination, 
it's just that most people are not going to be well versed in 
git/gitweb, aren't going to understand some of the subtleties  and 
aren't going to want to actually read the complexities in documentation. 
  So by recommending good, generic, defaults means that people will, by 
default, get a better result.

- John 'Warthog9' Hawley